(*
   CS 31600
   Hw 3
   Tests
*)

(* Global variables that make the interpreter output easier to read. *)
Control.Print.printDepth  := 20;
Control.Print.printLength := 30;


(* Exercise 2 Tests *)
member (1, []);
member (nil, []);
member (nil, [[]]);
member (0, [0]);
member (0, [1]);
member (1, [1, 3, 5, 7, 123]);
member (2, [1, 3, 5, 7, 123]);
member (123, [1, 3, 5, 7, 123]);
member (#"a", [#"c", #"a", #"n", #"t"]);
member (#"f", [#"c", #"a", #"n", #"t"]);
member ("cat", ["dog", "apples", "pears"]);
member ("cat", ["dog", "apples", "pears", "cat"]);


(* Exercise 3 Tests *)
less (5, [1, 2, 3, 4, 5, 6, 7, 8, 9, 0]);
less (1, []);
less (1, [1]);
less (9, [1, 2, 3]);
less (3, [7, 6, 4, 8, 1, 5, 2]);


(* Exercise 4 Tests *)
repeats [];
repeats [1];
repeats [1, 1];
repeats [1, 2];
repeats [1, 2, 2];
repeats [1, 2, 3];
repeats [1, 2, 2, 3, 4];
repeats [1, 2, 3, 2, 4];
repeats [1, 1, 1, 1, 1];
repeats [#"a", #"b", #"b", #"c"];
repeats [#"a", #"b", #"c", #"d"];
repeats ["cat", "dog", "cat", "dog"];


(* Exercise 6' Tests *)
insert (0, []);
insert (1, [2]);
insert (2, [1]);
insert (1, [2, 3]);
insert (2, [1, 3]);
insert (3, [1, 2]);
insert (3, [1, 2, 4, 5]);
insert (5, [1, 2, 3, 4]);
insert (4, [2, 5, 9, 10]);
insert (1, [1, 2, 3, 4]);
insert (3, [1, 2, 3, 4]);
insert (4, [1, 2, 3, 4]);


(* Exercise 6'' Tests *)
sort [];
sort [1];
sort [10, 5];
sort [2, 1, 3];
sort [3, 2, 1];
sort [1, 1, 1, 2];
sort [1, 2, 3, 4, 5];
sort [4, 2, 6, 1, 8, 2, 3];


(* Exercise 7' Tests *)
(* Here are a few comparison functions, from page 117 of the textbook. *)
fun icmp (a, b) = a < b;
fun ircmp(a, b) = a > b;
fun rcmp (a : real, b : real) = a < b;
fun rrcmp(a : real, b : real) = a > b;
fun ccmp (a : char, b : char) = a < b;
fun crcmp(a : char, b : char) = a > b;

(* Integers *)
insert2 (0, [], icmp);
insert2 (1, [2], icmp);
insert2 (2, [1], icmp);
insert2 (1, [2, 3], icmp);
insert2 (2, [1, 3], icmp);
insert2 (3, [1, 2], icmp);
insert2 (3, [1, 2, 4, 5], icmp);
insert2 (5, [1, 2, 3, 4], icmp);
insert2 (4, [2, 5, 9, 10], icmp);
insert2 (1, [1, 2, 3, 4], icmp);
insert2 (3, [1, 2, 3, 4], icmp);
insert2 (4, [1, 2, 3, 4], icmp);
insert2 (4, [8, 6, 5, 3, 1], ircmp);

sort2 ([], icmp);
sort2 ([3], icmp);
sort2 ([2, 2, 1], icmp);
sort2 ([3, 2, 1, 4, 3, 8, 0], icmp);
sort2 ([3, 2, 1, 4, 3, 8, 0], ircmp);
sort2 ([1, 2, 3], icmp);
sort2 ([3, 2, 1], icmp);
sort2 ([1, 2, 3], ircmp);
sort2 ([3, 2, 1], ircmp);

(* Reals *)
insert2 (0.0, [], rcmp);
insert2 (1.0, [2.0], rcmp);
insert2 (2.0, [1.0], rcmp);
insert2 (1.0, [2.0, 3.0], rcmp);
insert2 (2.0, [1.0, 3.0], rcmp);
insert2 (3.0, [1.0, 2.0], rcmp);
insert2 (3.0, [1.0, 2.0, 4.0, 5.0], rcmp);
insert2 (5.0, [1.0, 2.0, 3.0, 4.0], rcmp);
insert2 (4.0, [2.0, 5.0, 9.0, 10.0], rcmp);
insert2 (1.0, [1.0, 2.0, 3.0, 4.0], rcmp);
insert2 (3.0, [1.0, 2.0, 3.0, 4.0], rcmp);
insert2 (4.0, [1.0, 2.0, 3.0, 4.0], rcmp);
insert2 (4.0, [8.0, 6.0, 5.0, 3.0, 1.0], rrcmp);

sort2 ([], rcmp);
sort2 ([3.1], rcmp);
sort2 ([3.1, 3.1, 1.5], rcmp);
sort2 ([3.1, 2.1, 1.5, 5.34, 5.5, 5.54, 3.11], rcmp);
sort2 ([3.1, 2.1, 1.5, 5.34, 5.5, 5.54, 3.11], rrcmp);
sort2 ([1.2, 5.6, 7.8], rcmp);
sort2 ([3.1, 2.1, 1.5], rcmp);

(* Characters *)
insert2 (#"f", [], ccmp);
insert2 (#"a", [#"f"], ccmp);
insert2 (#"z", [#"f"], ccmp);
insert2 (#"b", [#"f", #"m"], ccmp);
insert2 (#"i", [#"f", #"m"], ccmp);
insert2 (#"u", [#"f", #"m"], ccmp);
insert2 (#"b", [#"d", #"e", #"h", #"m"], ccmp);
insert2 (#"f", [#"a", #"e", #"h", #"m"], ccmp);
insert2 (#"q", [#"a", #"e", #"h", #"m"], ccmp);

sort2 ([], ccmp);
sort2 ([#"f"], ccmp);
sort2 ([#"f", #"f", #"z", #"e", #"u"], ccmp);
sort2 ([#"f", #"a", #"z", #"e", #"u", #"t"], ccmp);
sort2 ([#"f", #"a", #"z", #"e", #"u", #"t"], crcmp);
sort2 ([#"a", #"b", #"c", #"d", #"e"], ccmp);
sort2 ([#"f", #"a", #"z", #"e", #"u"], ccmp);


(* Exercise 8' Tests *)
twiddle(nil: (real * int * char) list); (* explicitly type the empty list *)
twiddle([] : (char * real * int) list); (* explicitly type the empty list *)
twiddle([] : (int * char * real) list); (* explicitly type the empty list *)
twiddle [(1, 2.0, 3.0)];
twiddle [(5, 3, 2), (1, 1, 2)];
twiddle [(1.0, 2.0, 4), (1.0, 4.0, 6), (5.0, 3.0, 6)];


(* Exercise 9' Tests *)
flipper nil : int list;  (* explicitly type the empty list *)
flipper [] : char list;  (* explicitly type the empty list *)
flipper [] : real list;  (* explicitly type the empty list *)
flipper [1];
flipper [1, 2];
flipper [1, 4, 5];
flipper [1, 2, 3, 4, 5, 6, 7];
flipper [1, 2, 3, 4, 5, 6, 7, 8];
